#ifndef SIMULATOR_H_
#define SIMULATOR_H_
#include "Solution.h"
#include "RandomVariates.h"

double simulate(const Solution* const solution, bool isNoisy = true);

class Simulator
{
	public :
		virtual ~Simulator() {};
		virtual double simulation(const Solution* const solution) = 0; 
		virtual double gettruevalue(const Solution* const solution) = 0; 
		virtual int isGlobalOptimum(const Solution& solution) = 0;
		virtual int isLocalOptimum(const Solution& solution, const std::vector<double*> & A, const std::vector<double> b);
};

#endif /*SIMULATOR_H_*/
